# WhatsApp Group Scraper

Этот скрипт позволяет автоматически собирать данные участников из группы WhatsApp Web. Он прокручивает список участников, парсит их имена, номера телефонов и статусы, а затем сохраняет данные в CSV-файл.

## Особенности

- Автоматическая прокрутка списка участников.
- Парсинг имен, номеров телефонов и статусов.
- Удаление дубликатов.
- Автоматическое создание и скачивание CSV-файла.
- Гибкие настройки для адаптации под изменения в структуре HTML.

## Как использовать

### 1. Установка

1. Склонируйте репозиторий:
   ```bash
   git clone https://github.com/ваш-username/whatsapp-group-scraper.git
   cd whatsapp-group-scraper
   ```

2. Откройте WhatsApp Web в браузере и перейдите в нужную группу.

3. Откройте инструменты разработчика (обычно `F12` или `Ctrl+Shift+I`) и перейдите на вкладку "Console".

### 2. Настройка

Перед запуском скрипта убедитесь, что настройки в файле `script.js` соответствуют структуре HTML вашей версии WhatsApp Web. Основные настройки:

```javascript
const SETTINGS = {
    scrollDelay: 1000, // Задержка между прокрутками (в миллисекундах)
    scrollStep: 72, // Шаг прокрутки (в пикселях)
    enableLogs: true, // Включить логирование
    scrollContainerSelector: '.x1n2onr6.x1n2onr6.xyw6214.x78zum5.x1r8uery.x1iyjqo2.xdt5ytf.x6ikm8r.x1odjw0f.x1hc1fzr.x1tkvqr7', // Селектор контейнера для прокрутки
    participantSelector: '.x10l6tqk.xh8yej3.x1g42fcv', // Селектор элементов участников
    nameSelector: '.x1iyjqo2.x6ikm8r.x10wlt62.x1n2onr6.xlyipyv.xuxw1ft.x1rg5ohu._ao3e', // Селектор имени участника
    numberSelector: 'span._ajzr span._ao3e', // Селектор номера телефона
    statusSelector: '.x13faqbe._ao3e.selectable-text.copyable-text', // Селектор статуса участника
};
```

### 3. Запуск

1. Вставьте содержимое файла `script.js` в консоль браузера и нажмите `Enter`.

2. Скрипт начнет прокручивать список участников и собирать данные. В консоли будут отображаться логи процесса.

3. После завершения работы скрипта автоматически скачается CSV-файл с данными участников.

### 4. Результат

CSV-файл будет содержать три колонки:
- **Имя**: Имя участника.
- **Номер**: Номер телефона участника.
- **Статус**: Статус участника.

Пример CSV-файла:
```
Имя,Номер,Статус
"Max_Vedet","+34 624 34 42 05","Привет! Я использую WhatsApp."
"marina samaya","+34 610 04 16 09","Доступен"
"Leon","+34 622 59 40 28","🙈🙉🙊"
```

## Важные моменты

- **Задержка прокрутки**: Если WhatsApp блокирует автоматические действия, увеличьте значение `scrollDelay` в настройках.
- **Селекторы**: Если WhatsApp изменит структуру HTML, обновите селекторы в настройках.
- **Логирование**: Логи можно отключить, установив `enableLogs: false`.

## Лицензия

Этот проект распространяется под лицензией MIT. Подробности см. в файле [LICENSE](LICENSE).

---

## Как внести вклад

Если вы хотите внести вклад в проект, пожалуйста, создайте Pull Request. Мы будем рады вашим улучшениям и предложениям!

---

## Автор

[NW](https://git.softuniq.eu/NW)

---

Теперь другие пользователи смогут легко понять, как использовать ваш скрипт, и внести свой вклад в его развитие. 😊